import Vue from "vue";

declare module "vue/types/vue" {
  interface Vue {
    $post: IRequest;
    $get: IRequest;
    $post_auth: IRequest;
    $get_auth: IRequest;
  }
  interface VueConstructor {
    $post: IRequest;
    $get: IRequest;
    $post_auth: IRequest;
    $get_auth: IRequest;
  }
}

declare global {
  interface IAny {
    [index: string]: any;
  }
  interface IError {
    errmsg: string;
    errno: number;
  }
  interface IBaseResult<T = any> extends IError {
    data: T;
  }
  interface IRequest {
    <T = any>(url: string, data?: any): Promise<IResult<T>>;
  }

  interface IResult<T> extends Array<IError | null | T> {
    0: IError | null;
    1: T;
    length: 2;
  }

  interface IUser {}

  interface IBreadCrumbs {
    path: string;
    title: string;
  }
}
